commit a659e3bb2b942e5b7ad700490ad6794ff1470972
Author: freddy77 <freddy77>
Date:   Tue Aug 18 11:09:13 2009 +0000

    fix empty string binding for Sybase

diff --git a/ChangeLog b/ChangeLog
index b8e1207..0fb54fb 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Tue Aug 18 13:09:13 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/query.c: fix empty string binding for Sybase
+
 Tue Aug 18 09:27:03 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/tds_checks.c:
 	- remove too strict test (fails for Sybase LONGCHAR)
@@ -1719,4 +1722,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2839 2009/08/18 07:26:46 freddy77 Exp $
+$Id: ChangeLog,v 1.2840 2009/08/18 11:09:13 freddy77 Exp $
diff --git a/src/tds/query.c b/src/tds/query.c
index 3e07f95..346ddaf 100644
--- a/src/tds/query.c
+++ b/src/tds/query.c
@@ -46,7 +46,7 @@
 
 #include <assert.h>
 
-TDS_RCSID(var, "$Id: query.c,v 1.237 2009/05/28 16:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: query.c,v 1.238 2009/08/18 11:09:13 freddy77 Exp $");
 
 static void tds_put_params(TDSSOCKET * tds, TDSPARAMINFO * info, int flags);
 static void tds7_put_query_params(TDSSOCKET * tds, const char *query, size_t query_len);
@@ -1481,7 +1481,7 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	s = (char *) src;
 
 	/* convert string if needed */
-	if (curcol->char_conv && curcol->char_conv->flags != TDS_ENCODING_MEMCPY) {
+	if (curcol->char_conv && curcol->char_conv->flags != TDS_ENCODING_MEMCPY && colsize) {
 		size_t output_size;
 #if 0
 		/* TODO this case should be optimized */
@@ -1582,6 +1582,14 @@ tds_put_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		case 1:
 			if (is_numeric_type(curcol->column_type))
 				colsize = tds_numeric_bytes_per_prec[((TDS_NUMERIC *) src)->precision];
+			if (!colsize) {
+				tds_put_byte(tds, 1);
+				if (is_char_type(curcol->column_type))
+					tds_put_byte(tds, ' ');
+				else
+					tds_put_byte(tds, 0);
+				return TDS_SUCCEED;
+			}
 			colsize = MIN(colsize, 255);
 			tds_put_byte(tds, colsize);
 			break;

